// This file was generated by qtwaylandscanner
// source file is /usr/share/plasma-wayland-protocols/kde-screen-edge-v1.xml

#ifndef QT_WAYLAND_SERVER_KDE_SCREEN_EDGE_V1
#define QT_WAYLAND_SERVER_KDE_SCREEN_EDGE_V1

#include "wayland-server-core.h"
#include "wayland-kde-screen-edge-v1-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#include <unistd.h>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  kde_screen_edge_manager_v1
    {
    public:
        kde_screen_edge_manager_v1(struct ::wl_client *client, int id, int version);
        kde_screen_edge_manager_v1(struct ::wl_display *display, int version);
        kde_screen_edge_manager_v1(struct ::wl_resource *resource);
        kde_screen_edge_manager_v1();

        virtual ~kde_screen_edge_manager_v1();

        class Resource
        {
        public:
            Resource() : kde_screen_edge_manager_v1_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            kde_screen_edge_manager_v1 *kde_screen_edge_manager_v1_object;
            kde_screen_edge_manager_v1 *object() { return kde_screen_edge_manager_v1_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        enum error {
            error_invalid_border = 0, // the specified border value is invalid
            error_invalid_role = 1, // the surface has invalid role
            error_already_constructed = 2, // the surface already has a screen edge
        };

        enum border {
            border_top = 1, // top screen edge
            border_bottom = 2, // bottom screen edge
            border_left = 3, // left screen edge
            border_right = 4, // right screen edge
        };

    protected:
        virtual Resource *kde_screen_edge_manager_v1_allocate();

        virtual void kde_screen_edge_manager_v1_destroy_global();

        virtual void kde_screen_edge_manager_v1_bind_resource(Resource *resource);
        virtual void kde_screen_edge_manager_v1_destroy_resource(Resource *resource);

        virtual void kde_screen_edge_manager_v1_destroy(Resource *resource);
        virtual void kde_screen_edge_manager_v1_get_auto_hide_screen_edge(Resource *resource, uint32_t id, uint32_t border, struct ::wl_resource *surface);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::kde_screen_edge_manager_v1_interface m_kde_screen_edge_manager_v1_interface;

        static void handle_destroy(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_get_auto_hide_screen_edge(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t id,
            uint32_t border,
            struct ::wl_resource *surface);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            kde_screen_edge_manager_v1 *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  kde_auto_hide_screen_edge_v1
    {
    public:
        kde_auto_hide_screen_edge_v1(struct ::wl_client *client, int id, int version);
        kde_auto_hide_screen_edge_v1(struct ::wl_display *display, int version);
        kde_auto_hide_screen_edge_v1(struct ::wl_resource *resource);
        kde_auto_hide_screen_edge_v1();

        virtual ~kde_auto_hide_screen_edge_v1();

        class Resource
        {
        public:
            Resource() : kde_auto_hide_screen_edge_v1_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            kde_auto_hide_screen_edge_v1 *kde_auto_hide_screen_edge_v1_object;
            kde_auto_hide_screen_edge_v1 *object() { return kde_auto_hide_screen_edge_v1_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


    protected:
        virtual Resource *kde_auto_hide_screen_edge_v1_allocate();

        virtual void kde_auto_hide_screen_edge_v1_destroy_global();

        virtual void kde_auto_hide_screen_edge_v1_bind_resource(Resource *resource);
        virtual void kde_auto_hide_screen_edge_v1_destroy_resource(Resource *resource);

        virtual void kde_auto_hide_screen_edge_v1_destroy(Resource *resource);
        virtual void kde_auto_hide_screen_edge_v1_deactivate(Resource *resource);
        virtual void kde_auto_hide_screen_edge_v1_activate(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::kde_auto_hide_screen_edge_v1_interface m_kde_auto_hide_screen_edge_v1_interface;

        static void handle_destroy(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_deactivate(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_activate(
            ::wl_client *client,
            struct wl_resource *resource);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            kde_auto_hide_screen_edge_v1 *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
