// This file was generated by qtwaylandscanner
// source file is /usr/share/plasma-wayland-protocols/server-decoration.xml

#ifndef QT_WAYLAND_SERVER_SERVER_DECORATION
#define QT_WAYLAND_SERVER_SERVER_DECORATION

#include "wayland-server-core.h"
#include "wayland-server-decoration-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#include <unistd.h>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  org_kde_kwin_server_decoration_manager
    {
    public:
        org_kde_kwin_server_decoration_manager(struct ::wl_client *client, int id, int version);
        org_kde_kwin_server_decoration_manager(struct ::wl_display *display, int version);
        org_kde_kwin_server_decoration_manager(struct ::wl_resource *resource);
        org_kde_kwin_server_decoration_manager();

        virtual ~org_kde_kwin_server_decoration_manager();

        class Resource
        {
        public:
            Resource() : org_kde_kwin_server_decoration_manager_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            org_kde_kwin_server_decoration_manager *org_kde_kwin_server_decoration_manager_object;
            org_kde_kwin_server_decoration_manager *object() { return org_kde_kwin_server_decoration_manager_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        enum mode {
            mode_None = 0, // Undecorated: The surface is not decorated at all, neither server nor client-side. An example is a popup surface which should not be decorated.
            mode_Client = 1, // Client-side decoration: The decoration is part of the surface and the client.
            mode_Server = 2, // Server-side decoration: The server embeds the surface into a decoration frame.
        };

        void send_default_mode(uint32_t mode);
        void send_default_mode(struct ::wl_resource *resource, uint32_t mode);

    protected:
        virtual Resource *org_kde_kwin_server_decoration_manager_allocate();

        virtual void org_kde_kwin_server_decoration_manager_destroy_global();

        virtual void org_kde_kwin_server_decoration_manager_bind_resource(Resource *resource);
        virtual void org_kde_kwin_server_decoration_manager_destroy_resource(Resource *resource);

        virtual void org_kde_kwin_server_decoration_manager_create(Resource *resource, uint32_t id, struct ::wl_resource *surface);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::org_kde_kwin_server_decoration_manager_interface m_org_kde_kwin_server_decoration_manager_interface;

        static void handle_create(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t id,
            struct ::wl_resource *surface);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            org_kde_kwin_server_decoration_manager *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  org_kde_kwin_server_decoration
    {
    public:
        org_kde_kwin_server_decoration(struct ::wl_client *client, int id, int version);
        org_kde_kwin_server_decoration(struct ::wl_display *display, int version);
        org_kde_kwin_server_decoration(struct ::wl_resource *resource);
        org_kde_kwin_server_decoration();

        virtual ~org_kde_kwin_server_decoration();

        class Resource
        {
        public:
            Resource() : org_kde_kwin_server_decoration_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            org_kde_kwin_server_decoration *org_kde_kwin_server_decoration_object;
            org_kde_kwin_server_decoration *object() { return org_kde_kwin_server_decoration_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        enum mode {
            mode_None = 0, // Undecorated: The surface is not decorated at all, neither server nor client-side. An example is a popup surface which should not be decorated.
            mode_Client = 1, // Client-side decoration: The decoration is part of the surface and the client.
            mode_Server = 2, // Server-side decoration: The server embeds the surface into a decoration frame.
        };

        void send_mode(uint32_t mode);
        void send_mode(struct ::wl_resource *resource, uint32_t mode);

    protected:
        virtual Resource *org_kde_kwin_server_decoration_allocate();

        virtual void org_kde_kwin_server_decoration_destroy_global();

        virtual void org_kde_kwin_server_decoration_bind_resource(Resource *resource);
        virtual void org_kde_kwin_server_decoration_destroy_resource(Resource *resource);

        virtual void org_kde_kwin_server_decoration_release(Resource *resource);
        virtual void org_kde_kwin_server_decoration_request_mode(Resource *resource, uint32_t mode);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::org_kde_kwin_server_decoration_interface m_org_kde_kwin_server_decoration_interface;

        static void handle_release(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_request_mode(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t mode);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            org_kde_kwin_server_decoration *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
