/* Generated by wayland-scanner 1.23.0 */

#ifndef KDE_OUTPUT_MANAGEMENT_V2_SERVER_PROTOCOL_H
#define KDE_OUTPUT_MANAGEMENT_V2_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_kde_output_management_v2 The kde_output_management_v2 protocol
 * @section page_ifaces_kde_output_management_v2 Interfaces
 * - @subpage page_iface_kde_output_management_v2 - configuration of server outputs through clients
 * - @subpage page_iface_kde_output_configuration_v2 - configure single output devices
 * @section page_copyright_kde_output_management_v2 Copyright
 * <pre>
 *
 * SPDX-FileCopyrightText: 2008-2011 Kristian Høgsberg
 * SPDX-FileCopyrightText: 2010-2011 Intel Corporation
 * SPDX-FileCopyrightText: 2012-2013 Collabora, Ltd.
 * SPDX-FileCopyrightText: 2015 Sebastian Kügler <sebas@kde.org>
 * SPDX-FileCopyrightText: 2021 Méven Car <meven.car@enioka.com>
 * SPDX-FileCopyrightText: 2023 Xaver Hugl <xaver.hugl@kde.org>
 *
 * SPDX-License-Identifier: MIT-CMU
 * </pre>
 */
struct kde_output_configuration_v2;
struct kde_output_device_mode_v2;
struct kde_output_device_v2;
struct kde_output_management_v2;

#ifndef KDE_OUTPUT_MANAGEMENT_V2_INTERFACE
#define KDE_OUTPUT_MANAGEMENT_V2_INTERFACE
/**
 * @page page_iface_kde_output_management_v2 kde_output_management_v2
 * @section page_iface_kde_output_management_v2_desc Description
 *
 * This interface enables clients to set properties of output devices for screen
 * configuration purposes via the server. To this end output devices are referenced
 * by global kde_output_device_v2 objects.
 *
 * outputmanagement (wl_global)
 * --------------------------
 * request:
 * * create_configuration -> outputconfiguration (wl_resource)
 *
 * outputconfiguration (wl_resource)
 * --------------------------
 * requests:
 * * enable(outputdevice, bool)
 * * mode(outputdevice, mode)
 * * transformation(outputdevice, flag)
 * * position(outputdevice, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The server registers one outputmanagement object as a global object. In order
 * to configure outputs a client requests create_configuration, which provides a
 * resource referencing an outputconfiguration for one-time configuration. That
 * way the server knows which requests belong together and can group them by that.
 *
 * On the outputconfiguration object the client calls for each output whether the
 * output should be enabled, which mode should be set (by referencing the mode from
 * the list of announced modes) and the output's global position. Once all outputs
 * are configured that way, the client calls apply.
 * At that point and not earlier the server should try to apply the configuration.
 * If this succeeds the server emits the applied signal, otherwise the failed
 * signal, such that the configuring client is noticed about the success of its
 * configuration request.
 *
 * Through this design the interface enables atomic output configuration changes if
 * internally supported by the server.
 *
 * Warning! The protocol described in this file is a desktop environment implementation
 * detail. Regular clients must not use this protocol. Backward incompatible
 * changes may be added without bumping the major version of the extension.
 * @section page_iface_kde_output_management_v2_api API
 * See @ref iface_kde_output_management_v2.
 */
/**
 * @defgroup iface_kde_output_management_v2 The kde_output_management_v2 interface
 *
 * This interface enables clients to set properties of output devices for screen
 * configuration purposes via the server. To this end output devices are referenced
 * by global kde_output_device_v2 objects.
 *
 * outputmanagement (wl_global)
 * --------------------------
 * request:
 * * create_configuration -> outputconfiguration (wl_resource)
 *
 * outputconfiguration (wl_resource)
 * --------------------------
 * requests:
 * * enable(outputdevice, bool)
 * * mode(outputdevice, mode)
 * * transformation(outputdevice, flag)
 * * position(outputdevice, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The server registers one outputmanagement object as a global object. In order
 * to configure outputs a client requests create_configuration, which provides a
 * resource referencing an outputconfiguration for one-time configuration. That
 * way the server knows which requests belong together and can group them by that.
 *
 * On the outputconfiguration object the client calls for each output whether the
 * output should be enabled, which mode should be set (by referencing the mode from
 * the list of announced modes) and the output's global position. Once all outputs
 * are configured that way, the client calls apply.
 * At that point and not earlier the server should try to apply the configuration.
 * If this succeeds the server emits the applied signal, otherwise the failed
 * signal, such that the configuring client is noticed about the success of its
 * configuration request.
 *
 * Through this design the interface enables atomic output configuration changes if
 * internally supported by the server.
 *
 * Warning! The protocol described in this file is a desktop environment implementation
 * detail. Regular clients must not use this protocol. Backward incompatible
 * changes may be added without bumping the major version of the extension.
 */
extern const struct wl_interface kde_output_management_v2_interface;
#endif
#ifndef KDE_OUTPUT_CONFIGURATION_V2_INTERFACE
#define KDE_OUTPUT_CONFIGURATION_V2_INTERFACE
/**
 * @page page_iface_kde_output_configuration_v2 kde_output_configuration_v2
 * @section page_iface_kde_output_configuration_v2_desc Description
 *
 * outputconfiguration is a client-specific resource that can be used to ask
 * the server to apply changes to available output devices.
 *
 * The client receives a list of output devices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * outputmanagement global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the server to apply these settings in
 * an atomic fashion, for example through Linux' DRM interface.
 *
 * The server signals back whether the new settings have applied successfully
 * or failed to apply. outputdevice objects are updated after the changes have been
 * applied to the hardware and before the server side sends the applied event.
 * @section page_iface_kde_output_configuration_v2_api API
 * See @ref iface_kde_output_configuration_v2.
 */
/**
 * @defgroup iface_kde_output_configuration_v2 The kde_output_configuration_v2 interface
 *
 * outputconfiguration is a client-specific resource that can be used to ask
 * the server to apply changes to available output devices.
 *
 * The client receives a list of output devices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * outputmanagement global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the server to apply these settings in
 * an atomic fashion, for example through Linux' DRM interface.
 *
 * The server signals back whether the new settings have applied successfully
 * or failed to apply. outputdevice objects are updated after the changes have been
 * applied to the hardware and before the server side sends the applied event.
 */
extern const struct wl_interface kde_output_configuration_v2_interface;
#endif

/**
 * @ingroup iface_kde_output_management_v2
 * @struct kde_output_management_v2_interface
 */
struct kde_output_management_v2_interface {
	/**
	 * provide outputconfiguration object for configuring outputs
	 *
	 * Request an outputconfiguration object through which the client
	 * can configure output devices.
	 */
	void (*create_configuration)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t id);
};


/**
 * @ingroup iface_kde_output_management_v2
 */
#define KDE_OUTPUT_MANAGEMENT_V2_CREATE_CONFIGURATION_SINCE_VERSION 1

#ifndef KDE_OUTPUT_CONFIGURATION_V2_ERROR_ENUM
#define KDE_OUTPUT_CONFIGURATION_V2_ERROR_ENUM
/**
 * @ingroup iface_kde_output_configuration_v2
 * kde_output_configuration_v2 error values
 *
 * These error can be emitted in response to kde_output_configuration_v2 requests.
 */
enum kde_output_configuration_v2_error {
	/**
	 * the config is already applied
	 */
	KDE_OUTPUT_CONFIGURATION_V2_ERROR_ALREADY_APPLIED = 0,
};
/**
 * @ingroup iface_kde_output_configuration_v2
 * Validate a kde_output_configuration_v2 error value.
 *
 * @return true on success, false on error.
 * @ref kde_output_configuration_v2_error
 */
static inline bool
kde_output_configuration_v2_error_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case KDE_OUTPUT_CONFIGURATION_V2_ERROR_ALREADY_APPLIED:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* KDE_OUTPUT_CONFIGURATION_V2_ERROR_ENUM */

#ifndef KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_ENUM
#define KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_ENUM
/**
 * @ingroup iface_kde_output_configuration_v2
 * describes vrr policy
 *
 * Describes when the compositor may employ variable refresh rate
 */
enum kde_output_configuration_v2_vrr_policy {
	KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_NEVER = 0,
	KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_ALWAYS = 1,
	KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_AUTOMATIC = 2,
};
/**
 * @ingroup iface_kde_output_configuration_v2
 * Validate a kde_output_configuration_v2 vrr_policy value.
 *
 * @return true on success, false on error.
 * @ref kde_output_configuration_v2_vrr_policy
 */
static inline bool
kde_output_configuration_v2_vrr_policy_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_NEVER:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_ALWAYS:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_AUTOMATIC:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* KDE_OUTPUT_CONFIGURATION_V2_VRR_POLICY_ENUM */

#ifndef KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_ENUM
#define KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_ENUM
/**
 * @ingroup iface_kde_output_configuration_v2
 * describes RGB range policy
 *
 * Whether this output should use full or limited rgb.
 */
enum kde_output_configuration_v2_rgb_range {
	KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_AUTOMATIC = 0,
	KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_FULL = 1,
	KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_LIMITED = 2,
};
/**
 * @ingroup iface_kde_output_configuration_v2
 * Validate a kde_output_configuration_v2 rgb_range value.
 *
 * @return true on success, false on error.
 * @ref kde_output_configuration_v2_rgb_range
 */
static inline bool
kde_output_configuration_v2_rgb_range_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_AUTOMATIC:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_FULL:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_LIMITED:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* KDE_OUTPUT_CONFIGURATION_V2_RGB_RANGE_ENUM */

#ifndef KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_ENUM
#define KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_ENUM
/**
 * @ingroup iface_kde_output_configuration_v2
 * describes when auto rotate should be used
 */
enum kde_output_configuration_v2_auto_rotate_policy {
	KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_NEVER = 0,
	KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_IN_TABLET_MODE = 1,
	KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_ALWAYS = 2,
};
/**
 * @ingroup iface_kde_output_configuration_v2
 * Validate a kde_output_configuration_v2 auto_rotate_policy value.
 *
 * @return true on success, false on error.
 * @ref kde_output_configuration_v2_auto_rotate_policy
 */
static inline bool
kde_output_configuration_v2_auto_rotate_policy_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_NEVER:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_IN_TABLET_MODE:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_ALWAYS:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* KDE_OUTPUT_CONFIGURATION_V2_AUTO_ROTATE_POLICY_ENUM */

#ifndef KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_ENUM
#define KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_ENUM
/**
 * @ingroup iface_kde_output_configuration_v2
 * which source the compositor should use for the color profile on an output
 */
enum kde_output_configuration_v2_color_profile_source {
	KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_SRGB = 0,
	KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_ICC = 1,
	KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_EDID = 2,
};
/**
 * @ingroup iface_kde_output_configuration_v2
 * Validate a kde_output_configuration_v2 color_profile_source value.
 *
 * @return true on success, false on error.
 * @ref kde_output_configuration_v2_color_profile_source
 */
static inline bool
kde_output_configuration_v2_color_profile_source_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_SRGB:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_ICC:
		return version >= 1;
	case KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_EDID:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* KDE_OUTPUT_CONFIGURATION_V2_COLOR_PROFILE_SOURCE_ENUM */

/**
 * @ingroup iface_kde_output_configuration_v2
 * @struct kde_output_configuration_v2_interface
 */
struct kde_output_configuration_v2_interface {
	/**
	 * enable or disable an output
	 *
	 * Mark the output as enabled or disabled.
	 * @param outputdevice outputdevice to be en- or disabled
	 * @param enable 1 to enable or 0 to disable this output
	 */
	void (*enable)(struct wl_client *client,
		       struct wl_resource *resource,
		       struct wl_resource *outputdevice,
		       int32_t enable);
	/**
	 * switch output-device to mode
	 *
	 * Sets the mode for a given output.
	 * @param outputdevice outputdevice this mode change applies to
	 * @param mode the mode to apply
	 */
	void (*mode)(struct wl_client *client,
		     struct wl_resource *resource,
		     struct wl_resource *outputdevice,
		     struct wl_resource *mode);
	/**
	 * transform output-device
	 *
	 * Sets the transformation for a given output.
	 * @param outputdevice outputdevice this transformation change applies to
	 * @param transform transform enum
	 */
	void (*transform)(struct wl_client *client,
			  struct wl_resource *resource,
			  struct wl_resource *outputdevice,
			  int32_t transform);
	/**
	 * position output in global space
	 *
	 * Sets the position for this output device. (x,y) describe the
	 * top-left corner of the output in global space, whereby the
	 * origin (0,0) of the global space has to be aligned with the
	 * top-left corner of the most left and in case this does not
	 * define a single one the top output.
	 *
	 * There may be no gaps or overlaps between outputs, i.e. the
	 * outputs are stacked horizontally, vertically, or both on each
	 * other.
	 * @param outputdevice outputdevice this position applies to
	 * @param x position on the x-axis
	 * @param y position on the y-axis
	 */
	void (*position)(struct wl_client *client,
			 struct wl_resource *resource,
			 struct wl_resource *outputdevice,
			 int32_t x,
			 int32_t y);
	/**
	 * set scaling factor of this output
	 *
	 * Sets the scaling factor for this output device.
	 * @param outputdevice outputdevice this scale change applies to
	 * @param scale scaling factor
	 */
	void (*scale)(struct wl_client *client,
		      struct wl_resource *resource,
		      struct wl_resource *outputdevice,
		      wl_fixed_t scale);
	/**
	 * apply configuration changes to all output devices
	 *
	 * Asks the server to apply property changes requested through
	 * this outputconfiguration object to all outputs on the server
	 * side.
	 *
	 * The output configuration can be applied only once. The
	 * already_applied protocol error will be posted if the apply
	 * request is called the second time.
	 */
	void (*apply)(struct wl_client *client,
		      struct wl_resource *resource);
	/**
	 * release the outputconfiguration object
	 *
	 * 
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * set overscan value
	 *
	 * Set the overscan value of this output device with a value in
	 * percent.
	 * @param outputdevice outputdevice overscan applies to
	 * @param overscan overscan value
	 */
	void (*overscan)(struct wl_client *client,
			 struct wl_resource *resource,
			 struct wl_resource *outputdevice,
			 uint32_t overscan);
	/**
	 * set the VRR policy
	 *
	 * Set what policy the compositor should employ regarding its use
	 * of variable refresh rate.
	 * @param outputdevice outputdevice this VRR policy applies to
	 * @param policy the vrr policy to apply
	 */
	void (*set_vrr_policy)(struct wl_client *client,
			       struct wl_resource *resource,
			       struct wl_resource *outputdevice,
			       uint32_t policy);
	/**
	 * RGB range
	 *
	 * Whether full or limited color range should be used
	 * @param outputdevice outputdevice the rgb range applies to
	 */
	void (*set_rgb_range)(struct wl_client *client,
			      struct wl_resource *resource,
			      struct wl_resource *outputdevice,
			      uint32_t rgb_range);
	/**
	 * Select which primary output to use
	 *
	 * 
	 * @since 2
	 */
	void (*set_primary_output)(struct wl_client *client,
				   struct wl_resource *resource,
				   struct wl_resource *output);
	/**
	 * Set the order of outputs
	 *
	 * The order of outputs can be used to assign desktop environment
	 * components to a specific screen, see kde_output_order_v1 for
	 * details. The priority is 1-based for outputs that will be
	 * enabled after this changeset is applied, all outputs that are
	 * disabled need to have the index set to zero.
	 * @param outputdevice outputdevice the index applies to
	 * @param priority the priority of the output
	 * @since 3
	 */
	void (*set_priority)(struct wl_client *client,
			     struct wl_resource *resource,
			     struct wl_resource *outputdevice,
			     uint32_t priority);
	/**
	 * change if HDR should be enabled
	 *
	 * Sets whether or not the output should be set to HDR mode.
	 * @param outputdevice outputdevice this setting applies to
	 * @param enable_hdr 1 to enable, 0 to disable hdr
	 * @since 4
	 */
	void (*set_high_dynamic_range)(struct wl_client *client,
				       struct wl_resource *resource,
				       struct wl_resource *outputdevice,
				       uint32_t enable_hdr);
	/**
	 * set the brightness for sdr content
	 *
	 * Sets the brightness of standard dynamic range content in nits.
	 * Only has an effect while the output is in HDR mode. Note that
	 * while the value is in nits, that doesn't necessarily translate
	 * to the same brightness on the screen.
	 * @param outputdevice outputdevice this setting applies to
	 * @since 4
	 */
	void (*set_sdr_brightness)(struct wl_client *client,
				   struct wl_resource *resource,
				   struct wl_resource *outputdevice,
				   uint32_t sdr_brightness);
	/**
	 * change if a wide color gamut should be used
	 *
	 * Whether or not the output should use a wide color gamut
	 * @param outputdevice outputdevice this setting applies to
	 * @param enable_wcg 1 to enable, 0 to disable wcg
	 * @since 4
	 */
	void (*set_wide_color_gamut)(struct wl_client *client,
				     struct wl_resource *resource,
				     struct wl_resource *outputdevice,
				     uint32_t enable_wcg);
	/**
	 * change when auto rotate should be used
	 *
	 * 
	 * @param outputdevice outputdevice this setting applies to
	 * @since 5
	 */
	void (*set_auto_rotate_policy)(struct wl_client *client,
				       struct wl_resource *resource,
				       struct wl_resource *outputdevice,
				       uint32_t policy);
	/**
	 * change the used icc profile
	 *
	 * 
	 * @param outputdevice outputdevice this setting applies to
	 * @since 6
	 */
	void (*set_icc_profile_path)(struct wl_client *client,
				     struct wl_resource *resource,
				     struct wl_resource *outputdevice,
				     const char *profile_path);
	/**
	 * override metadata about the screen's brightness limits
	 *
	 * 
	 * @param outputdevice outputdevice this setting applies to
	 * @param max_peak_brightness -1 for not overriding, or positive values in nits
	 * @param max_frame_average_brightness -1 for not overriding, or positive values in nits
	 * @param min_brightness -1 for not overriding, or positive values in 0.0001 nits
	 * @since 7
	 */
	void (*set_brightness_overrides)(struct wl_client *client,
					 struct wl_resource *resource,
					 struct wl_resource *outputdevice,
					 int32_t max_peak_brightness,
					 int32_t max_frame_average_brightness,
					 int32_t min_brightness);
	/**
	 * describes which gamut is assumed for sRGB applications
	 *
	 * This can be used to provide the colors users assume sRGB
	 * applications should have based on the default experience on many
	 * modern sRGB screens.
	 * @param outputdevice outputdevice this setting applies to
	 * @param gamut_wideness 0 means rec.709 primaries, 10000 means native primaries
	 * @since 7
	 */
	void (*set_sdr_gamut_wideness)(struct wl_client *client,
				       struct wl_resource *resource,
				       struct wl_resource *outputdevice,
				       uint32_t gamut_wideness);
	/**
	 * which source the compositor should use for the color profile on an output
	 *
	 * 
	 * @param outputdevice outputdevice this setting applies to
	 * @param color_profile_source the color profile source
	 * @since 8
	 */
	void (*set_color_profile_source)(struct wl_client *client,
					 struct wl_resource *resource,
					 struct wl_resource *outputdevice,
					 uint32_t color_profile_source);
	/**
	 * brightness multiplier
	 *
	 * Set the brightness modifier of the output. It doesn't specify
	 * any absolute values, but is merely a multiplier on top of other
	 * brightness values, like sdr_brightness and brightness_metadata.
	 * 0 is the minimum brightness (not completely dark) and 10000 is
	 * the maximum brightness. This is supported while HDR is active in
	 * versions 8 and below, or when the device supports the
	 * brightness_control capability in versions 9 and above.
	 * @param outputdevice outputdevice this setting applies to
	 * @param brightness brightness in 0-10000
	 * @since 9
	 */
	void (*set_brightness)(struct wl_client *client,
			       struct wl_resource *resource,
			       struct wl_resource *outputdevice,
			       uint32_t brightness);
};

#define KDE_OUTPUT_CONFIGURATION_V2_APPLIED 0
#define KDE_OUTPUT_CONFIGURATION_V2_FAILED 1

/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_APPLIED_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_FAILED_SINCE_VERSION 1

/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_ENABLE_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_MODE_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_POSITION_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SCALE_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_APPLY_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_OVERSCAN_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_VRR_POLICY_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_RGB_RANGE_SINCE_VERSION 1
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_PRIMARY_OUTPUT_SINCE_VERSION 2
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_PRIORITY_SINCE_VERSION 3
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_HIGH_DYNAMIC_RANGE_SINCE_VERSION 4
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_SDR_BRIGHTNESS_SINCE_VERSION 4
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_WIDE_COLOR_GAMUT_SINCE_VERSION 4
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_AUTO_ROTATE_POLICY_SINCE_VERSION 5
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_ICC_PROFILE_PATH_SINCE_VERSION 6
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_BRIGHTNESS_OVERRIDES_SINCE_VERSION 7
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_SDR_GAMUT_WIDENESS_SINCE_VERSION 7
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_COLOR_PROFILE_SOURCE_SINCE_VERSION 8
/**
 * @ingroup iface_kde_output_configuration_v2
 */
#define KDE_OUTPUT_CONFIGURATION_V2_SET_BRIGHTNESS_SINCE_VERSION 9

/**
 * @ingroup iface_kde_output_configuration_v2
 * Sends an applied event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
kde_output_configuration_v2_send_applied(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, KDE_OUTPUT_CONFIGURATION_V2_APPLIED);
}

/**
 * @ingroup iface_kde_output_configuration_v2
 * Sends an failed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
kde_output_configuration_v2_send_failed(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, KDE_OUTPUT_CONFIGURATION_V2_FAILED);
}

#ifdef  __cplusplus
}
#endif

#endif
